%define	major	1
%define	libname	%mklibname modprobe %{major}
%define	devname	%mklibname -d modprobe

%bcond_without	diet

Summary:	Tools for managing Linux kernel modules
Name:		module-init-tools
Version:	3.16
Release:	3
Source0:	http://www.kernel.org/pub/linux/utils/kernel/module-init-tools/%name-%version.tar.bz2
Source1:	blacklist-mdv.conf
Source3:	modprobe.default
Source5:	modprobe.preload
Source6:	ipw-no-associate.conf
# from Fedora package
Source20:	blacklist-compat.conf
Patch0:		module-init-tools-3.16-new-api.diff
# split:
Patch1:		module-init-tools-3.16-libify.patch
Patch2:		module-init-tools-3.16-dont-break-depend.patch
# add --use-modprobe-c to ./generate-modprobe.conf:
# ./generate-modprobe.conf is no more used by the package and it's
# probably time to not ship it anymore.
Patch4:		module-init-tools-3.16-generate-modprobe.conf-no-defaults.patch
# fail on unknown symbol:
Patch5:		module-init-tools-3.16-failed.unknown.symbol.patch
# (blino) /lib/module-init-tools/ldetect-lst-modules.alias needs to be
# parsed in its own group, so that modprobe.d/*.conf files are
# preferred over it
#
# If ldetect-lst-modules.alias was in modprobe.d, both aliases from
# this file and other .conf files would be loaded, while we want to be
# able to completely override or disable ldetect-lst aliases from
# modprobe.d/*.conf files
Patch6:		module-init-tools-3.16-preferred.patch
# build fix:
Patch7:		module-init-tools-3.16-fix-build.patch
# exit() is not a user-friendly user managment method in a library:
Patch8:		module-init-tools-3.16-libify-2.patch
# rename warn() -> mod_warn() (mga#3309):
Patch9:		module-init-tools-3.16-libify-4.patch
# quiet API:
Patch10:	module-init-tools-3.16-libify-7.patch
Patch20:	module-init-tools-3.16-xz-support.patch
License:	GPLv2+
Group:		System/Kernel and hardware
Url:		http://www.kernel.org/pub/linux/utils/kernel/module-init-tools/
BuildRequires:	autoconf2.5
BuildRequires:	glibc-static-devel
BuildRequires:	libz-devel
BuildRequires:	liblzma-devel
BuildRequires:	docbook-utils docbook-dtd41-sgml
%if %{with diet}
BuildRequires:	dietlibc-devel
%endif

%description
This package contains a set of programs for loading, inserting, and
removing kernel modules for Linux (versions 2.5.47 and above). It
serves the same function that the "modutils" package serves for Linux
2.4.

%package -n	%{libname}
Summary:	Library for %{name}
Group:		System/Libraries

%description -n	%{libname}
Library for %{name}.

%package -n	%{devname}
Summary:	Development files for %{name}
Group:		Development/C
%rename		module-init-tools-devel
Provides:	modprobe-devel = %{EVRD}
Requires:	%{libname} = %{version}

%description -n %{devname}
Development files for %{name}

%prep
%setup -q
%patch0 -p1 -b .new-api
%patch1 -p1 -b .lib
%patch2 -p1 -b .dont-break-depend
%patch4 -p1 -b .generate-modprobe.conf-no-defaults
%patch5 -p1 -b .failed-symb
%patch6 -p1 -b .preferred
%patch7 -p1 -b .fixbuild
%patch8 -p1 -b .lib2
%patch9 -p1 -b .lib4
%patch10 -p1 -b .quiet_api
%patch20 -p1 -b .xz~

autoreconf -fi
# XXX: Remove config.status, otherwise configure will get confused
rm -f config.status

%build
%serverbuild

%if %{with diet}
mkdir -p objs-diet
pushd objs-diet
CONFIGURE_TOP=.. \
%configure2_5x	--enable-zlib \
		--enable-liblzma \
		--disable-shared \
		--bindir=/bin \
		--sbindir=/sbin \
		--libdir=/%{_lib} \
		--libexecdir=/%{_lib}

# (tv) fix static build:
perl -pi -e 'warn "TOTO", s/$/ -Wl,-Bstatic -lz -Wl,-Bdynamic/ if /LDADD.*libmodtools.a$/' Makefile 
make CFLAGS="-Os" CC="diet gcc"
popd
%endif

mkdir -p objs
pushd objs
CONFIGURE_TOP=.. \
%configure2_5x	--enable-zlib \
		--enable-liblzma \
		--bindir=/bin \
		--sbindir=/sbin \
		--libdir=/%{_lib} \
		--libexecdir=/%{_lib}

make  CFLAGS="%{optflags} -fPIC"
popd

%install
pushd objs
%makeinstall_std transform=
mv %{buildroot}/bin/lsmod %{buildroot}/sbin
popd

%if %{with diet}
install objs-diet/.libs/libmodprobe.a -D %{buildroot}%{_prefix}/lib/dietlibc/lib-%{_arch}/libmodprobe.a
install objs-diet/insmod.static -D %{buildroot}/sbin/insmod.static
install objs-diet/modprobe -D %{buildroot}/sbin/modprobe-static
%endif

mkdir -p %{buildroot}{%{_libdir},%{_includedir}}
install -m644 modprobe.h list.h %{buildroot}%{_includedir}

install -d -m755 %{buildroot}%{_sysconfdir}
install -d -m755 %{buildroot}%{_sysconfdir}/depmod.d/
install -m644 %{SOURCE5} %{buildroot}%{_sysconfdir}
install -d -m755 %{buildroot}%{_sysconfdir}/modprobe.d/
install -m644 %{SOURCE1} %{SOURCE6} %{SOURCE20} %{buildroot}%{_sysconfdir}/modprobe.d

install -d -m755 %{buildroot}/lib/module-init-tools
install -m644 %{SOURCE3} -D %{buildroot}%{_sysconfdir}/modprobe.d/00_modprobe.conf

install -m755 generate-modprobe.conf %{buildroot}/sbin/generate-modprobe.conf

%pre
# /etc/modprobe.conf is deprecated. All config files should be put in
# /etc/modprobe.d/ directory now.
if [ -e /etc/modprobe.conf ]; then
	if [ ! -s /etc/modprobe.conf ]; then
		rm -f /etc/modprobe.conf
	elif [ ! -e /etc/modprobe.d/modprobe.conf ]; then
		mv /etc/modprobe.conf /etc/modprobe.d/
	fi
fi

%files
%doc AUTHORS ChangeLog NEWS README
%doc TODO stress_modules.sh
%dir %{_sysconfdir}/depmod.d/
%config(noreplace) %{_sysconfdir}/modprobe.preload
%dir %{_sysconfdir}/modprobe.d/
%config(noreplace) %{_sysconfdir}/modprobe.d/*
%dir /lib/module-init-tools
/sbin/*
%{_mandir}/*/*

%files -n %{devname}
%{_includedir}/*.h
/%{_lib}/libmodprobe.a
%if %{with diet}
%{_prefix}/lib/dietlibc/lib-%{_arch}/libmodprobe.a
%endif
/%{_lib}/libmodprobe.la
/%{_lib}/libmodprobe.so

%files -n %{libname}
/%{_lib}/libmodprobe.so.*


%changelog
* Mon Jan 30 2012 Franck Bui <franck.bui@mandriva.com> 3.16-3
+ Revision: 769926
- fix syntax error in %%pre scriptlet

* Mon Jan 30 2012 Franck Bui <franck.bui@mandriva.com> 3.16-2
+ Revision: 769885
- don't support old /etc/modules.conf and put all config files /etc/modprobe.d

* Fri Jan 06 2012 Per Øyvind Karlsen <peroyvind@mandriva.org> 3.16-1
+ Revision: 758242
- don't bother shipping 'COPYING' as it's provided by 'common-licenses' package
- update license tag (GPL -> GPLv2+)
- consistently use %%{_sysconfdir} macro
- don't remove /sbin/insmod.static on %%{ix86}
- drop obsoletes on %%{_lib}modprobe0-devel
- use %%rename macro for module-init-tools-devel
- drop explicit library package name dependency
- remove ancient conflicts/obsoletes on modutils & devfsd
- use %%bcond for dietlibc build
- drop dead %%toalternate macro
- fix link order in xz patch
- regenerate xz patch (P20)
- merge changes from mageia:
  	o provide static tools
  	o reduce number of runtime warnings
  	o drop kernel 2.4 -> 2.6 module mapping which is uneeded for long time
  	o drop patch 3 and move modprobe.default in modprobe.d
  	o drop patch 6 and move ldetect-lst in modprobe.d
  	  (still read before kernel aliases list)
  	o document remaining patches
  	o patch 9: rename warn() as mod_warn() (mga#3309):
  	o patch 10: API for quiet mode in ldetect
  	o patch 8: exit() is not a user-friendly user managment method in a library
  	o move modprobe.default and modprobe.compat from /lib64 to /lib on 64-bit
  	  as they are plain text files and that is where modprobe looks for them
  	o do not automatically mount/umount binfmt_misc fs when binfmt_misc
  	  module is inserted/removed, it interferes with automatic modprobing
  	  by mount command and causes boot delays with systemd (mga #2246)
  	o rediff all patches
  	o Blacklist viafb (mga #1185)
- remove ancient trigger on some mdv2008.0 version
- apply some cosmetics
- clean out deprecated rpm stuff

* Mon May 02 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 3.6-18
+ Revision: 662316
- fix not returning on non-existent file, resulting ENOENT not being set

* Fri Apr 29 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 3.6-17
+ Revision: 660179
- add support for xz compressed modules (P8)

* Sun Apr 17 2011 Anssi Hannula <anssi@mandriva.org> 3.6-16
+ Revision: 654062
- remove now unneeded patch affecting blacklist behaviour (proprietary nvidia
  does not rely on them anymore)
- remove now unwanted blacklist entries for DKMS and KMS drivers (handled by
  udev and display_driver_helper)

* Sat Mar 12 2011 Funda Wang <fwang@mandriva.org> 3.6-15
+ Revision: 643936
- new devel package policy
- cleanup old conditonal definition

* Thu Jan 06 2011 Thomas Backlund <tmb@mandriva.org> 3.6-14mdv2011.0
+ Revision: 629071
- drop firewire blacklist now as all affected kernels are 2.6.37

* Mon Nov 01 2010 Thomas Backlund <tmb@mandriva.org> 3.6-13mdv2011.0
+ Revision: 591361
- switch to new firewire (JuJu) stack
  (old ieee1394 stack is removed in upstream kernel 2.6.37-rc1)
  * remove blacklist of firewire modules
  * blacklist old ieee1394 modules

* Mon Oct 04 2010 Thomas Backlund <tmb@mandriva.org> 3.6-12mdv2011.0
+ Revision: 582906
- use the correct firewire blacklist file

* Mon Oct 04 2010 Thomas Backlund <tmb@mandriva.org> 3.6-11mdv2011.0
+ Revision: 582873
- add blacklist for new firewire stack (juju) so we can enable it in
  main kernel without breaking current setups, but still allow testing
  of apps against new core (old stack is sceduled for removal around
  2.6.37-39)

* Wed May 05 2010 Anssi Hannula <anssi@mandriva.org> 3.6-10mdv2010.1
+ Revision: 542673
- disable automatic loading of KMS drivers by udev for now as they
  interfere with vesa/nv drivers; a proper solution will be quite complex
  (the drivers will continue to work as they will be loaded by initrd,
   by X.org server itself, or by modprobe.preload)
- fix 'blacklist' entry in config file to only affect module internal
  aliases as per documentation (blacklist-internal-aliases-only.patch)

* Wed May 05 2010 Anssi Hannula <anssi@mandriva.org> 3.6-9mdv2010.1
+ Revision: 542228
- blacklist the proprietary drivers, as udev would now otherwise load
  them even if free driver is in use (this does not prevent the
  proprietary drivers from working)

* Mon Apr 19 2010 Thomas Backlund <tmb@mandriva.org> 3.6-8mdv2010.1
+ Revision: 536875
- restore version 3.6 for now
- update to 3.11.1
- fix url

  + Anssi Hannula <anssi@mandriva.org>
    - disable PC speaker module by default as per discussion in cooker@ (it
      can be re-enabled by adding "pcspkr" line in /etc/modprobe.preload)

* Wed Oct 21 2009 Olivier Blin <blino@mandriva.org> 3.6-7mdv2010.0
+ Revision: 458552
- remove /lib/libmodprobe.so.0* earlier on x86_64 package upgrade to
  make depmod succeed, since the libs have been moved from /lib to
  /lib64 (#54758)

* Tue Oct 20 2009 Olivier Blin <blino@mandriva.org> 3.6-6mdv2010.0
+ Revision: 458429
- make module-init-tools conflict with libmodprobe older than 3.6,
  because depmod needs the newly added index_create symbol, and major
  has not been bumped (#54758)

* Mon Oct 19 2009 Pascal Terjan <pterjan@mandriva.org> 3.6-5mdv2010.0
+ Revision: 458241
- Have strict requires on libmodprobe version, fixes big breakage on upgrade

* Mon Oct 12 2009 Olivier Blin <blino@mandriva.org> 3.6-4mdv2010.0
+ Revision: 456850
- put back dietelibc files in /usr/lib/dietlibc on x86_64
  (revert part of commit 374916)

* Tue May 12 2009 Luiz Fernando Capitulino <lcapitulino@mandriva.com> 3.6-3mdv2010.0
+ Revision: 374917
- Bump release
- Install libs in lib64 when building for 64-bits
- Move read_config_file_bin() to libmodprobe
- Rediff patches with offset warnings after the change
- Rediff some patches to apply cleanly

* Wed Feb 04 2009 Luiz Fernando Capitulino <lcapitulino@mandriva.com> 3.6-1mdv2009.1
+ Revision: 337610
- Update to v3.6
- rework libmodprobe (again), now only needed functions are
  part of the library
- Drop already merged patches

* Mon Jan 26 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 3.5-3mdv2009.1
+ Revision: 333782
- Removed hardcoded regulatory domain setting of cfg80211 module,
  handling can be dynamic now with 'iw' (see "iw reg set", crda).

  + Luiz Fernando Capitulino <lcapitulino@mandriva.com>
    - Update depmod file trucation fix (minor)

* Mon Jan 12 2009 Luiz Fernando Capitulino <lcapitulino@mandriva.com> 3.5-1mdv2009.1
+ Revision: 328765
- Fix modules.dep truncation (#46884)
- Update the "preferred" patch for 3.5 version
- Merge work done on branch module-init-tools-3.5-upgrade

* Thu Dec 11 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 3.3-pre11.41mdv2009.1
+ Revision: 313444
- "Unfuzzy" following patches:
  module-init-tools-3.2-pre8-dont-break-depend.patch
  module-init-tools-3.2-pre8-modprobe-default.patch
- module-init-tools-3.3-pre11-cache.patch is currently causing depmod to fail
  (abort) with latest kernels (2.6.28 based), temporarily disable it until more
  investigation is done.

* Fri Oct 03 2008 Frederic Crozat <fcrozat@mandriva.com> 3.3-pre11.40mdv2009.0
+ Revision: 291032
- Patch13 (Jakub Jelinek): speedup modprobe and create a cache for aliases

* Thu Jul 24 2008 Olivier Blin <blino@mandriva.org> 3.3-pre11.39mdv2009.0
+ Revision: 245603
- do not use "Boot Protocol" drivers for usb mice and keyboards, we
  prefer usbhid, and they cause problems when loaded together with
  usbhid (#37726, #40861)

  + Oden Eriksson <oeriksson@mandriva.com>
    - rebuilt against dietlibc-devel-0.32

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Wed May 28 2008 Olivier Blin <blino@mandriva.org> 3.3-pre11.37mdv2009.0
+ Revision: 212438
- adapt default mac80211 regulatory domain option (use ieee80211_regdom=JP for cfg80211)

* Tue Apr 01 2008 Olivier Blin <blino@mandriva.org> 3.3-pre11.36mdv2008.1
+ Revision: 191480
- own /etc/depmod.d

* Fri Mar 21 2008 Olivier Blin <blino@mandriva.org> 3.3-pre11.35mdv2008.1
+ Revision: 189321
- add default options to mac80211 module to support channels > 11 (#35849)

* Thu Mar 06 2008 Makoto Dei <makoto@turbolinux.co.jp> 3.3-pre11.34mdv2008.1
+ Revision: 180998
- added i82875p_edac to blacklist-mdv (#34789 and #37731)

  + Thierry Vignaud <tv@mandriva.org>
    - rebuild with fixed %%serverbuild macro

* Tue Jan 15 2008 Thierry Vignaud <tv@mandriva.org> 3.3-pre11.32mdv2008.1
+ Revision: 153182
- rebuild
- kill re-definition of %%buildroot on Pixel's request

  + Olivier Blin <blino@mandriva.org>
    - restore BuildRoot

* Thu Sep 27 2007 Olivier Blin <blino@mandriva.org> 3.3-pre11.30mdv2008.0
+ Revision: 93303
- mark modprobe.d files as config
- disable automatic association for ipw2100/ipw2200/ipw3945

* Tue Sep 11 2007 Olivier Blin <blino@mandriva.org> 3.3-pre11.29mdv2008.0
+ Revision: 84472
- use ldetect-lst aliases from /lib/module-init-tools/, not from /usr

* Sun Sep 09 2007 Olivier Blin <blino@mandriva.org> 3.3-pre11.28mdv2008.0
+ Revision: 83577
- do not read depends twice (fix loop, #33368)

* Sun Sep 09 2007 Olivier Blin <blino@mandriva.org> 3.3-pre11.27mdv2008.0
+ Revision: 83429
- use module aliases from first match only

* Sun Sep 09 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 3.3-pre11.26mdv2008.0
+ Revision: 83198
- Fixed out of memory condition triggered by udev.

* Sat Sep 08 2007 Olivier Blin <blino@mandriva.org> 3.3-pre11.25mdv2008.0
+ Revision: 82425
- use ldetect-lst's preferred-modules.alias before kernel's modules.alias

* Thu Aug 30 2007 Thierry Vignaud <tv@mandriva.org> 3.3-pre11.24mdv2008.0
+ Revision: 75561
- remove modutils on upgrade

* Wed Aug 15 2007 Olivier Blin <blino@mandriva.org> 3.3-pre11.23mdv2008.0
+ Revision: 63513
- build dietlibc library with -Os

* Tue Aug 14 2007 Olivier Blin <blino@mandriva.org> 3.3-pre11.22mdv2008.0
+ Revision: 63352
- add dietlibc lib
- do not install man pages twice
- build objects in a subdir

* Tue Aug 14 2007 Thierry Vignaud <tv@mandriva.org> 3.3-pre11.21mdv2008.0
+ Revision: 63161
- provides modprobe-devel

* Tue Aug 14 2007 Thierry Vignaud <tv@mandriva.org> 3.3-pre11.20mdv2008.0
+ Revision: 62851
- try harder to update

* Mon Aug 13 2007 Thierry Vignaud <tv@mandriva.org> 3.3-pre11.19mdv2008.0
+ Revision: 62839
- fix upgrade of module-init-tools-devel

* Mon Aug 13 2007 Thierry Vignaud <tv@mandriva.org> 3.3-pre11.18mdv2008.0
+ Revision: 62730
- provide back module-init-tools-devel

* Mon Aug 13 2007 Thierry Vignaud <tv@mandriva.org> 3.3-pre11.17mdv2008.0
+ Revision: 62692
- patch 11: exit() is not a user-friendly user managment method in a library
- link shared library with -lz in order to prevent alter every users

* Mon Aug 13 2007 Thierry Vignaud <tv@mandriva.org> 3.3-pre11.15mdv2008.0
+ Revision: 62675
- build a shared library

* Mon Aug 06 2007 Thierry Vignaud <tv@mandriva.org> 3.3-pre11.14mdv2008.0
+ Revision: 59219
- package missing list.h too

* Sat Aug 04 2007 Thierry Vignaud <tv@mandriva.org> 3.3-pre11.13mdv2008.0
+ Revision: 58832
- patch 1: libify modprobe for ldetect
- rediff patches 2, 3 & 7 due to that code move

* Tue Jun 12 2007 Olivier Blin <blino@mandriva.org> 3.3-pre11.12mdv2008.0
+ Revision: 38117
- blacklist rivatv in a new blacklist-mdv file (#30531)

* Thu May 17 2007 Olivier Blin <blino@mandriva.org> 3.3-pre11.11mdv2008.0
+ Revision: 27671
- add blacklist-compat list from Fedora packages to blacklist framebuffer drivers (#30531), ISDN hisax drivers, watchdog drivers (they need a daemon) on coldplug/hotplug

* Sun May 13 2007 Andrey Borzenkov <arvidjaar@mandriva.org> 3.3-pre11.10mdv2008.0
+ Revision: 26559
- Remove alternatives now when modutils are gone

* Sat Apr 28 2007 trem <trem@mandriva.org> 3.3-pre11.9mdv2008.0
+ Revision: 18959
- fix insmod when using it without absolute path

* Fri Apr 20 2007 Thierry Vignaud <tv@mandriva.org> 3.3-pre11.8mdv2008.0
+ Revision: 16186
- new release


* Thu Dec 28 2006 Luiz Fernando Capitulino <lcapitulino@mandriva.com> 3.3-pre4.7mdv2007.0
+ Revision: 102405
- Update to 3.3-pre4
- Fix URL (module-init-tools is hosted at a new location now)

  + Gustavo Pichorim Boiko <boiko@mandriva.com>
    - Import module-init-tools

